
/***********************************************************************
'                     MAKETeX.c
'This program is designed to take a lastxlast array in a file (where the
'array is stored row by row with negative numbers serving as end of row
'markers) and converts it to a TeX source file which when processed will
'print the array in pages each containing a 25x48 subarray.  The entries in
'the original lastxlast array must have only entries i, 0<=i<=999.
'Designed for use with the files BOOK1 and BOOK2.
'The corresponding output files will usually be TABLE1.TEX and TABLE2.TEX.
converted from the .bas program 4/16/94.
'************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

main()
{   /* Declarations */
    char s[100],c,noalign[8], path[20], inpath[15], outpath[15],junk[8];
    char yes[2], date[15];
    int last, r, rpp, response, rowf, rowl, colf, coll;
    int **im,  page_row, page_col, firstrow, lastrow;
    int temp, row, col,i, tableno, lprow, lpcol;
    int prow,pcol,lrb,lcb,page, so, response2;
    int firstcol,lastcol, count;
    int e;
    FILE *ifp, *ofp, *fp, *sofp[2];
  /* End Declarations */


/* Initial message */
L0:printf("\n\n\%s\n%s\n","Enter the name of the file to be converted to ",
	  "TeX.  This will usually be book1 or book2");

   gets(inpath);
L4: printf("\n%s\n%s\n","To what file name should the TeX file be",
	   " written?  Must be different from the input file.");
    gets(outpath);
  /* See if the file outpath exists */
    if((ofp=fopen(outpath,"r"))!=NULL)
       {close(ofp);
	printf("\n\n%s%s\n%s\n", outpath," already exists.",
	       "  Overwrite? (y/n)");
	gets(yes);
	if(*yes=='n')
	  goto L4;
       }
   ofp = fopen(outpath,"w");
	/* Check the number of forms in input file */
   ifp=fopen(inpath,"r");
   last= -1;
L1: fscanf(ifp,"%d",&temp);
    if(temp>=0)
      {last = last + 1;
       goto L1;}
    printf("\n%s%d\n","The number of the last form is ",last);

 /* Dimension the array im and read in input file */
    im =calloc(last+1,sizeof(int*));
    for(row=0;row<=last;++row)
     if((im[row]=calloc(last+1,sizeof(int)))==NULL)
	{printf("\n%s%d\n","out of memory at row ",row);
	 goto L0;
	}
    printf("\n%s%s\n%s\n","Now reading in ",inpath,
	    " This will take a while");
    rewind(ifp);
    for(row=0;row<=last;++row)
     {for(col=0;col<=last;++col)
	fscanf(ifp,"%d",&im[row][col]);
      fscanf(ifp,"%d",&temp);}     /* read end of row marker */
   fclose(ifp);

      printf("\n%s\n", "Today's date?");
      gets(date);
      printf("\n%s\n","Will the output be Table 1 or Table 2?");
      printf("%s\n","Respond 1 or 2.");
      scanf("%d",&tableno);
      fprintf(ofp,"%s%d%s%s%s\n", "\\headline={\\centerline{\\rm TABLE ",
	      tableno, " \\hskip.5in ", date, "}}");
      fprintf(ofp,"%s%s\n","\\vsize 9.65in  \\voffset -.3in ",
	      "\\hsize7.5in \\hoffset-.5in");

/* Determine last row (lprow) and last column (lpcol) in page array */
   /* c to here */
   lprow = (last / 48) + 1;
   lpcol = (last / 25) + 1;
   for( prow = 1; prow<= lprow;++prow)
   for( pcol = 1; pcol<= lpcol;++pcol)
	       /*  print page heading */
     {firstrow = 48 * (prow - 1);
      lastrow = 48 * prow - 1;
      firstcol = 25 * (pcol - 1);
      lastcol = 25 * pcol - 1;
      fprintf(ofp,"%s%d%s%d%s%s%d%s%d%s\n",
	      "ROWS ", firstrow, " TO ", lastrow, " \\hskip.5in ",
	      "COLUMNS ", firstcol, " TO ", lastcol, "\\par");
      fprintf(ofp,"%s\n%s\n%s\n", "\\medskip", "{\\offinterlineskip ",
		  "\\tabskip 0pt");
      fprintf(ofp,"%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
	     "\\halign{\\strut \\hfil # & \\vrule # &\\hfil#",  /* template */
	     "&\\hfil# &\\hfil# &\\hfil# &\\hfil#",            /* for the */
	     "&\\hfil# &\\hfil# &\\hfil# &\\hfil#",            /* rows */
	     "&\\hfil# &\\hfil# &\\hfil# &\\hfil#",
	     "&\\hfil# &\\hfil# &\\hfil# &\\hfil#",
	     "&\\hfil# &\\hfil# &\\hfil# &\\hfil#",
	     "&\\hfil# &\\hfil# &\\hfil# &\\hfil# \\cr");
      fprintf(ofp,"%s", "&");            /* start the column heading line */
      for(col = firstcol;col<=lastcol;++col)
	{fprintf(ofp,"%s", "&");
	 if(0 <= col && col < 10)
	  fprintf(ofp,"%1d", col);         /* print the column headings */
	 if(9 < col && col < 100)
	  fprintf(ofp,"%2d", col);
	 if(99 < col && col < 1000)
	  fprintf(ofp,"%3d", col);
       }
     fprintf(ofp,"%s\n", "\\cr");          /* this finishes the column heads*/
     /* Now a blank line below column headings with the
	column widths laid out */
     fprintf(ofp,"%s\n%s\n%s\n%s\n%s\n",
	   "\\hskip7mm&&\\hskip7mm&\\hskip7mm&\\hskip7mm&\\hskip7mm&\\hskip7mm",
	   "&\\hskip9mm&\\hskip7mm&\\hskip7mm&\\hskip7mm&\\hskip7mm",
	   "&\\hskip9mm&\\hskip7mm&\\hskip7mm&\\hskip7mm&\\hskip7mm",
	   "&\\hskip9mm&\\hskip7mm&\\hskip7mm&\\hskip7mm&\\hskip7mm",
	   "&\\hskip9mm&\\hskip7mm&\\hskip7mm&\\hskip7mm&\\hskip7mm \\cr");
     fprintf(ofp,"%s\n", "\\noalign{\\hrule}"); /* line below column headings*/
     count = 0;                  /* start counting for six row blocks */
     for(row = firstrow;row<=lastrow;++row)
       {if(0 <= row && row < 10)
	 fprintf(ofp,"%1d", row);   /* row headings */
	if(9 < row && row < 100)
	 fprintf(ofp,"%2d", row);
	if(99 < row && row < 1000)
	 fprintf(ofp,"%3d", row);
	fprintf(ofp,"%s", "&");
	for(col = firstcol;col<=lastcol;++col)
	  {if((row <= last) && (col <= last))  /* print the row itself */
	     {fprintf(ofp,"%s", "&");
	      e = im[row][col];
	      if(0 <= e && e < 10)
		fprintf(ofp,"%1d", e);
	      if(9 < e && e < 100)
		fprintf(ofp,"%2d", e);
	      if(99 < e && e < 1000)
		fprintf(ofp,"%3d", e);
	     }
	   if((row > last) || (col>last))   /* unless it's not in range */
	     fprintf(ofp,"%s", "&-");
	  }
       fprintf(ofp,"%s\n","\\cr");           /* finish the row */
       count = count + 1;
       if(count== 6)                        /* blank line after 6 rows */
	 {if((row != lastrow))
	    fprintf(ofp,"%s\n", "&& \\cr");
	  count = 0;
	 }
       }
     fprintf(ofp,"%s\n", "}}");
     fprintf(ofp,"%s\n", "\\par\\vfill \\eject");
    }
   fprintf(ofp,"%s\n", "\\end");
   fclose(ofp);
   exit(1);
 }


