/***************************** weakac.c ********************************
Weakac.c was revised in Jan. 98 so that when menu option 7 is chosen it
looks for the file models.tex (like the old weakac did) but if models.tex
is not found, it then looks for models.dat, a stripped down version of
models.tex.  The original description of weakac is below.

This program is the primary program for extracting information from
the data base for the weak AC project.  It is a modification of the
program vw.c combined with the programs vone.c and rd_mod.c.
The program first reads in the data base which is stored
in the files book1 and book2 which must be present in the area from
which the program is run.  Either the file models.tex or the file
models.dat must be present if menu option 7 (below) is chosen.

The following assumptions are made about
the files book1 and book2:
     1.  files consists of a square matrices
     2.  the entries are natural numbers between 0 and 7
     3.  each entry is stored in a field of width 4
     4.  the matrix is stored row by row each row terminated
	 with a -1 and new line symbol.
The matrix is read into a character array then the main menu is typed
on the screen offering the options:
     1.  seeing the meanings of the implication codes
     2.  seeing what is know about the implication <form n implies form k>
	 for any two form numbers n and k
     3.  getting information about a single form
     4.  seeing table 1 restricted to any subset of the forms.
     5.  seeing a submatrix of table 1 of consecutive rows and columns.
     6.  seeing how an implication or non-implication follows from
	 those with references in part V
     7.  seeing the models in which a form is true and models in which it
	 is false
     8.  exiting the program
Under option 3 the output is written at ten items per line to eliminate
some unix file problems.
 revised 7/7/94
 revised 2/17/97 so that it doesn't crash when input is incorrect (these
 revisions were to vw.c)  weakac.c was written 7/3/97   weakac2 1/23/98*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

   /* Declarations - all global*/
int tempform, tr, tfrms[10], fr, ffrms[10], namel, tnm, fnm, ind;
int trueinM[100], falseinM[100], flag, flag1;
char textline[100], word[25], modname[30], test12[13];
    void rd_mod();
    char  **im;
    int **r1;  /* arrays for table 1 and table 2  */
    char s[100],c,noalign[8], path[20], inpath[15], outpath[15],junk[8];
    char yes[2], path2[15], c0[2];
    int k, n, reason, fi, fip, j, dev;
    int last, r, rpp, response, rowf, rowl, colf, coll;
    int form, temp, row, col,i, counter, nforms, *formno;
    int prow,pcol,lrb,lcb,page, so, response2;
    int firstrow, lastrow, firstcol,lastcol, count;
    int *implyr, *cimply;
    int nl, ro, co;
    FILE *ifp, *ofp, *fp, *sofp[2];
  /* End Declarations */
void main()
{
/* Initial message */
L0:printf("\n\n\%s\n%s\n","              Reading in the data base.",
	      "              Please wait.");
   strcpy(inpath,"book1");
   strcpy(path2,"book2");
	/* Check the number of forms in inputfile */
   if((ifp=fopen(inpath,"r")) == NULL)
     {printf("\n%s\n%s","The data file book1 is missing.",
		      "See the file readme.txt for setup instructions" );
      exit(1);
     }
   printf("\n%s\n","Now checking the number of forms.");
   last= -1;
L1: fscanf(ifp,"%4d",&temp);
    if(temp>=0)
      {last = last + 1;
       goto L1;}
    printf("\n%s%d\n","The number of the last form is ",last);

   nl = last;
  /* dimension the arrays implyr and cimply */
  implyr = calloc(last + 1,sizeof(int));
  cimply = calloc(last + 1, sizeof(int));

 /* Dimension the arrays im and read in the two files */

    im =calloc(nl+1,sizeof(char*));
    for(ro=0;ro<=nl;++ro)
     if((im[ro]=calloc(nl+1,sizeof(char)))==NULL)
	{printf("\n%s%d\n","Sorry, out of memory at row ",ro);
	 exit(1);
	}
    printf("\n%s%s%s%s\n%s\n","Now reading in ",inpath," and ",path2,
	    " This will take a while");
    rewind(ifp);
    for(ro=0;ro<=last;++ro)
     {for(co=0;co<=last;++co)
	fscanf(ifp,"   %c",&im[ro][co]);
      fscanf(ifp,"%d",&temp);}     /* read end of row marker */
   fclose(ifp);
   if((ifp=fopen(path2,"r"))==NULL)
     {printf("\n%s\n%s","The data file book2 is missing.",
	     "See the file readme.txt for setup instructions.");
      exit(1);
     }
    r1 =calloc(nl+1,sizeof(int*));
    for(ro=0;ro<=nl;++ro)
     if((r1[ro]=calloc(nl+1,sizeof(int)))==NULL)
	{printf("\n%s%d\n","Sorry, out of memory at row.",ro);
	 exit(1);
	}
    for(ro=0;ro<=last;++ro)
     {for(co=0;co<=last;++co)
	fscanf(ifp,"%d",&r1[ro][co]);
      fscanf(ifp,"%d",&temp);}     /* read end of row marker */
   fclose(ifp);
    printf("\n%s\n", "Reading complete");


    sofp[1]=stdout;
    so=1;                                 /*print only to screen unless
					  changed below*/
L4: printf("%s\n%s\n","would you like for the output to be printed in a ",
	   "file as well as on the screen? (y/n).");
    gets(yes);
    if(*yes=='y')
       {so=2;
	printf("\n%s\n","Type name of output file");
	gets(outpath);
	if((ofp=fopen(outpath,"r"))!=NULL)
	   {fclose(ofp);
	    printf("\n\n%s%s\n%s\n", outpath," already exists.",
		   "  Overwrite? (y/n)");
	    gets(yes);
	    if(*yes=='n')
	      goto L4;
	   }
	ofp = fopen(outpath,"w");
	sofp[2]=ofp;
      }
L3: printf("\n\n%s\n\n%s%s\n\n%s\n%s%s\n\n%s%s\n\n%s%s\n\n%s\n%s%s\n",
	   "                MAIN MENU",
	   "1. see the meanings of the implication codes",
	   "    type 1 <enter>",
	   "2. see what is known about the implication <form n implies form k>",
	   "   for any two form numbers n and k",
	   "    type 2 <enter>",
	   "3. get information about a single form",
	   "    type 3 <enter>",
	   "4. see table 1 restricted to any subset of the forms",
	   "   type 4 <enter>",
	   "5. see a submatrix of table 1 consisting of consecutive",
	   "   rows and columns",
	   "   type 5 <enter>");
    printf("\n%s\n%s%s\n\n%s\n%s%s\n\n%s%s\n\n\n",
	   "6. see how an implication or non-implication follows from those",
	   "   with a reference in part V",
	   "   type 6 <enter>",
	   "7. see the models in which a form is true and those in which",
	   "   it is false",
	   "   type 7 <enter>",
	   "8. exit the program",
	   "   type 8 <enter>"  );

    scanf("%d",&response);
    if(response != 1 && response !=2 && response != 3 && response != 4 &&
       response != 5 && response != 6 && response != 7 && response != 8)
      {printf("\n%d%s",response," is not a valid response");
       goto L3;
      }

      /* OPTION 1 */

    if(response==1)
      {printf("\n%s\n\n%s\n%s\n%s\n%s\n%s",
      "If the entry at row n, column k in table 1 is:",
      "0   we know nothing about the implication <form n implies form k>",
      "1   form n implies form k and there is a reference in part V",
      "2   form n implies form k but there is no reference in part V",
      "    (choose option 6 from the main menu to see how the implication",
      "    follows from those with references in part V)");
      printf("\n%s\n%s\n%s\n%s\n%s\n%s",
      "3   there is a model of ZF in which form n is true and form k",
      "    is false and a reference may be found in part V",
      "4   there is a model of ZF in which form n is true and form k",
      "    is false but no reference in part V (choose option 6 from the",
      "    main menu to see how the non-implication follows from those",
      "    with references in part V)");
      printf("\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
      "5   there is a model of ZF$0$ in which form n is true and form k",
      "    is false and a reference may be found in part V",
      "6   there is a model of ZF$^0$ in which form n is true and form k",
      "    is false but no reference in part V (choose option 6 from the",
      "    main menu to see how the non-implication follows from those",
      "    with references in part 5)",
      "7   it is unknown whether or not form n implies form k and we have",
      "    found the question asked in the literature; see part V for a",
      "    a reference");
LR:   printf("%s%s\n",
	     "Return to main menu ---- type 1  <enter>",
	     "     Exit program ---- type 2  <enter>");
      scanf("%d",&response);
       if(response != 1 && response !=2)
	 {printf("\n%d%s\n",response," is not a valid response");
	  goto LR;
	 }
       if(response ==1) goto L3;
       if(response==2) exit(1);
      }

      /* OPTION 2 */

    else if(response==2)
LR2:  { printf("\n\n%s%s\n%s\n","To see the status of the implication ",
	       " <form n implies form k> type:","n,k  <enter>.");
	scanf("%d,%d",&row,&col);
	if(row < 0 || row > last || col <0 || col > last)
	  {printf("\n%s\n%s%d","n and k must be non-negative",
	  " integers less than ",last + 1);
	   goto LR2;
	  }
	printf("\n\n%s%3d%s%3d%s%c\n","The entry at position (",row,",",
	       col,") is ",im[row][col]);
	printf("%s\n","This means that ");
	if(im[row][col]=='1' || im[row][col] == '2')
	  printf("%s%d%s%d%s\n","form ",row," implies form ",col,".");
	else if(im[row][col]=='3' || im[row][col]=='4')
	  printf("%s%d%s%d%s\n","form ",row," does not imply form ",col,
		 " in ZF.");
	else if(im[row][col]=='5' || im[row][col]=='6')
	  printf("%s%d%s%d%s\n","form ",row," does not imply form ",col,
		 " in ZF$^0$.");
	else if(im[row][col] == '0' || im[row][col]== '7')
	  printf("%s%d%s%d%s\n","the status of the implication <form ",
		 row," implies form ",col,"> is unknown");
	printf("\n%s\n%s\n",
	       "Choose option 1 from the main menu to see more on the meanings",
	       " of the implication codes.");
      if(so==2)
       {
	fprintf(ofp,"\n\n%s%3d%s%3d%s%c\n","The entry at position (",row,",",
	       col,") is ",im[row][col]);
	fprintf(ofp,"%s\n","This means that ");
	if(im[row][col]=='1' || im[row][col] == '2')
	  fprintf(ofp,"%s%d%s%d%s\n","form ",row," implies form ",col,".");
	else if(im[row][col]=='3' || im[row][col]=='4')
	  fprintf(ofp,"%s%d%s%d%s\n","form ",row," does not imply form ",col,
		 " in ZF.");
	else if(im[row][col]=='5' || im[row][col]=='6')
	  fprintf(ofp,"%s%d%s%d%s\n","form ",row," does not imply form ",col,
		 " in ZF$^0$.");
	else if(im[row][col] == '0' || im[row][col]== '7')
	  fprintf(ofp,"%s%d%s%d%s\n","the status of the implication <form ",
		 row," implies form ",col,"> is unknown");
	fprintf(ofp,"\n%s\n%s\n",
	       "Choose option 1 from the main menu to see more on the meanings",
	       " of the implication codes.");
       }
Ls:   printf("\n%s\n%s\n",
	     "Return to main menu   type 1  <enter>",
	     "Exit program          type 2  <enter>");
      scanf("%d",&response);
       if(response != 1 && response !=2)
	 {printf("\n%d%s\n",response," is not a valid response");
	  goto Ls;
	 }
       if(response ==1) goto L3;
       if(response==2) exit(1);

      }

      /* OPTION 3 */

    else if(response==3)
      { printf("\n\n%s\n","Enter the form number followed by <enter>.");
	scanf("%d",&form);
	gets(junk);
	if(form < 0 || form > last)
	  {printf("\n%s\n%s%d","Form numbers must be non-negative integers",
		  "less than ",last+1);
	   goto L3;
	  }
	for(i=1;i<=so;++i)  /* so is 1 if no file, 2 if there is a file */
	  { fprintf(sofp[i],"\n\n%s%d%s\n","The following forms imply form ",
		    form," in ZF^0.");
	   counter=0;
	   for(row=0;row<=last;++row)
	     if(im[row][form]=='1' || im[row][form]=='2')
	       {counter = counter + 1;
		fprintf(sofp[i],"%4d,", row);
		if(counter ==10)
		  {fprintf(sofp[i],"\n");
		   counter = 0;
		  }
	       }

	    if(i==1)
	      {printf("\n%s\n","Type <enter> for more.");
	       gets(junk);
	      }
	    fprintf(sofp[i],"\n\n%s%d%s\n", "Form ", form ,
		    " implies the following forms in ZF^0:  ");
	    counter=0;
	    for(col=0;col<=last;++col)
	      if(im[form][col]=='1' || im[form][col]=='2')
	       {counter=counter+1;
		fprintf(sofp[i],"%4d,", col);
		if(counter==10)
		  {fprintf(sofp[i],"\n");
		   counter = 0;
		  }
	       }
	    if(i==1)
	      {printf("\n%s\n","Type <enter> for more.");
	       gets(junk);
	      }
	    fprintf(sofp[i],"\n\n%s%s%d%s\n","The following forms do not ",
		    "imply form ", form, " in ZF^0");
	    counter = 0;
	    for(row=0;row<=last;++row)
	      if(im[row][form]=='5' || im[row][form]=='6')
	       {counter = counter + 1;
		fprintf(sofp[i],"%4d,",row);
		if(counter ==10)
		  {fprintf(sofp[i],"\n");
		   counter = 0;
		  }
		}
	    if(i==1)
	      {printf("\n%s\n","Type <enter> for more.");
	       gets(junk);
	      }
	    fprintf(sofp[i],"\n\n%s%s%d%s\n","The following forms do not ",
		    "imply form ", form, " in ZF");
	    counter = 0;
	    for(row=0;row<=last;++row)
	      if(im[row][form]=='3' || im[row][form]=='4')
	       { counter = counter + 1;
		fprintf(sofp[i],"%4d,",row);
		if(counter ==10)
		  {fprintf(sofp[i],"\n");
		   counter = 0;
		  }
	      }
	    if(i==1)
	      {printf("\n%s\n","Type <enter> for more.");
	       gets(junk);
	      }
	    fprintf(sofp[i],"\n\n%s%d%s%s\n","Form ", form,
		    " does not imply the following forms ",
		    "in ZF^0:  ");
	    counter = 0;
	    for(col=0;col<=last;++col)
	      if(im[form][col]=='5' || im[form][col]=='6')
	       { counter = counter + 1;
		fprintf(sofp[i],"%4d,",col);
		  if(counter ==10)
		  {fprintf(sofp[i],"\n");
		   counter = 0;
		  }
	      }
	    if(i==1)
	      {printf("\n%s\n","Type <enter> for more.");
	       gets(junk);
	      }
	    fprintf(sofp[i],"\n\n%s%d%s%s\n","Form ", form,
		    " does not imply the following forms ",
		    "in ZF:  ");
	    counter = 0;
	    for(col=0;col<=last;++col)
	      if(im[form][col]=='3' || im[form][col]=='4')
		{counter = counter + 1;
		fprintf(sofp[i],"%4d,",col);
		  if(counter ==10)
		  {fprintf(sofp[i],"\n");
		   counter = 0;
		  }
	      }
	  }
Lt:   printf("\n%s\n%s\n",
	     "Return to main menu   type 1  <enter>",
	     "Exit program          type 2  <enter>");
      scanf("%d",&response);
       if(response != 1 && response !=2)
	 {printf("\n%d%s\n",response," is not a valid response");
	  goto Lt;
	 }
       if(response ==1) goto L3;
       if(response==2) exit(1);


      }

      /* OPTION 5 */

    else if (response==5)
     { /*This is a section of c code that prints a range of rows and columns
   from book1 assuming im is a char array */
       printf("\nrow and column numbers must be between 0 and %d",last);
       printf("\n\n first row to be printed\n");
       scanf("%d", &rowf);
       printf("\n\n last row to be printed\n");
       scanf("%d",&rowl);
       printf("\n\n first column to be printed \n");
       scanf("%d",&colf);
       printf("\n\n last column to be printed\n");
       scanf("%d%c",&coll,&c);
       if(rowf < 0 || rowf > last || rowl < 0 || rowl > last ||
	  colf < 0 || colf > last || coll < 0 || coll > last)
	  {printf("\n%s\n%s%d","Form numbers must be non-negative integers",
		  "less than ",last+1);
	   goto L3;
	  }
       lrb = ((rowl - rowf)/18) + 1;
       lcb = ((coll - colf)/18) + 1;
       for(prow=1;prow<=lrb;++prow)
	  { for(pcol=1;pcol<=lcb;++pcol)
	      { page=(prow-1)*lcb + pcol;
		if((1<=page)&&(page<=(lrb*lcb)))
		  {    firstrow = 18*(prow - 1) + rowf;
		       lastrow = 18*prow - 1 + rowf;
		       firstcol = 18*(pcol - 1) + colf;
		       lastcol = 18*pcol - 1 + colf;
		       for(i=1;i<=so;++i)    /* Do twice if file is chosen*/
			 {fprintf(sofp[i],"\n\n%s%3d%s%3d%s%3d%s%3d\n",
			      "rows ",firstrow," to ",lastrow,"   columns ",
			      firstcol," to ",lastcol);
			  fprintf(sofp[i],"      ");
/* column headings */     for(col=firstcol;col<=lastcol;++col)
			     fprintf(sofp[i],"%4d",col);
			  fprintf(sofp[i],"\n\n");
			  count= 0;
			  for(row=firstrow;row<=lastrow;++row)
 /* row heading */          { fprintf(sofp[i],"%3d   ",row);
			      for(col=firstcol;col<=lastcol;++col)
/* print the row */              {if((row<=rowl)&&(col<=coll))
				  fprintf(sofp[i],"%4c",im[row][col]);
				 if((row > rowl)||(col > coll))
				  fprintf(sofp[i],"    ");
				}
			      count = count + 1;
			      if(count==6)
				{fprintf(sofp[i],"\n");
				 count = 0;
				}
			      fprintf(sofp[i],"\n");
			    }
			  fprintf(sofp[i],"%s%8d%s","page",page,
				   "        press <enter> for next page");
			 }
			gets(junk);

		   }
	      }
	  }
Lu:   printf("\n%s\n%s\n",
	     "Return to main menu   type 1  <enter>",
	     "Exit program          type 2  <enter>");
      scanf("%d",&response);
       if(response != 1 && response !=2)
	 {printf("\n%d%s\n",response," is not a valid response");
	  goto Lu;
	 }
       if(response ==1) goto L3;
       if(response==2) exit(1);
     }

     /* OPTION 4 */

	 else if (response==4)
     { /*This is a section of c code that prints the matrix
       restricted to any subset of the set of forms.*/
       printf("\n\n How many forms\n");
       scanf("%d", &nforms);
       formno=calloc(nforms+1,sizeof(int));
       printf("\n\n%s\n",
	      " Enter the form numbers separated by <enter>");
       for(i=1;i<=nforms;++i)
	   {scanf("%d",&formno[i]);
	    if(formno[i] < 0 || formno[i] > last)
	      {printf("\n%s\n%s%d","Form numbers must be non-negative integers",
		     "less than ",last+1);
	       goto L3;
	      }
	   }
       lrb = ((nforms- 1)/18) + 1;
       lcb = lrb;
       for(prow=1;prow<=lrb;++prow)
	  { for(pcol=1;pcol<=lcb;++pcol)
	      { page=(prow-1)*lcb + pcol;
		if((1<=page)&&(page<=(lrb*lcb)))
		  {    firstrow = 18*(prow - 1) + 1;
		       lastrow = 18*prow - 1 + 1;
		       firstcol = 18*(pcol - 1) + 1;
		       lastcol = 18*pcol - 1 + 1;
		       for(i=1;i<=so;++i)    /* Do twice if file is chosen*/
			 {
			  fprintf(sofp[i],"\n");
			  fprintf(sofp[i],"      ");
/* column headings */     for(col=firstcol;col<=lastcol;++col)
			     if(col <= nforms)
			       fprintf(sofp[i],"%4d",formno[col]);
			  fprintf(sofp[i],"\n\n");
			  count= 0;
			  for(row=firstrow;row<=lastrow;++row)
 /* row heading */          if(row<= nforms)
			     { fprintf(sofp[i],"%3d   ",formno[row]);
			      for(col=firstcol;col<=lastcol;++col)
/* print the row */              {if((row<=nforms)&&(col<=nforms))
				  fprintf(sofp[i],"%4c",
				    im[formno[row]][formno[col]]);
				 if((row > nforms)||(col > nforms))
				  fprintf(sofp[i],"    ");
				}
			      count = count + 1;
			      if(count==6)
				{fprintf(sofp[i],"\n");
				 count = 0;
				}
			      fprintf(sofp[i],"\n");
			    }
			  fprintf(sofp[i],"%s%8d%s","page",page,
				   "        type n <enter> for next page");
			 }
		      scanf("%s",junk);/*	gets(junk);*/

		   }
	      }
	  }
LV:   printf("\n%s\n%s\n",
	     "Return to main menu   type 1  <enter>",
	     "Exit program          type 2  <enter>");
      scanf("%d",&response);
       if(response != 1 && response !=2)
	 {printf("\n%d%s\n",response," is not a valid response");
	  goto LV;
	 }
       if(response ==1) goto L3;
       if(response==2) exit(1);
     }

     /* OPTION 6 */

    else if(response==6)
     {
Lw: printf("\n\n%s\n%s\n", "Enter row and column numbers of the entry you ",
       "want to see.  row,column <ret>:  ");
    printf("\n%s\n%s%d\n",
	   "Both the row and column number you enter must be between ",
	   " 0 and ",last);
    scanf("%d,%d",&row, &col);
/*   printf("\n%s\n","continue? (y/n)");  note: this part is not acitve
   scanf("%s",c0);
   if(*c0== 'n')
     goto Lw;  */
    if(im[row][col]=='4' || im[row][col]=='6')
      {k = 0;
       n = 0;
       implyr[0] = row;
       cimply[0] = col;
       while(im[implyr[k]][cimply[n]] == '4' || /* get a non-implication */
	     im[implyr[k]][cimply[n]] == '6')   /* in implyr[k] and */
	 {ro = implyr[k];                       /* cimply[n] which is */
	  co = cimply[n];                       /* referenced in rfb1 */
	  reason = r1[ro][co];
	  if((im[reason][ro] == '1' || im[reason][ro] =='2') &&
	     (im[reason][co] == '3' || im[reason][co] == '4'))
	    {k = k+1;
	     implyr[k] = reason;
	    }
	  else if((im[co][reason] == '1' || im[co][reason] == '2') &&
		  (im[ro][reason] == '3' || im[ro][reason] == '4'))
	    {n = n+1;
	     cimply[n] = reason;
	    }
	  else if((im[reason][ro] == '1' || im[reason][ro] =='2') &&
		  (im[reason][co] == '5' || im[reason][co] == '6'))
	    {k = k+1;
	     implyr[k] = reason;
	    }
	  else if((im[co][reason] == '1' || im[co][reason] == '2') &&
		  (im[ro][reason] == '5' || im[ro][reason] == '6'))
	    {n = n+1;
	     cimply[n] = reason;
	    }

	 }
/* Now insert forms into the implication strings implyr and cimply so
   that each implication is referenced in RFB1 */
       i=0;
       while(i<k)
	 {fi = implyr[i];
	  fip = implyr[i+1];
	  while(im[fip][fi] != '1')
	    {for(j=k; j>= i+1; --j)
	      implyr[j+1] = implyr[j];    /* for implyr */
	     implyr[i+1] = r1[fip][fi];
	     fip = implyr[i+1];
	     k= k + 1;
	    }
	  i=i+1;
	  }
       i=0;
       while(i<n)
	 {fi = cimply[i];
	  fip = cimply[i+1];
	  while(im[fi][fip] != '1')
	    {for(j=n; j>= i+1; --j)
	      cimply[j+1] = cimply[j];    /* for cimply */
	     cimply[i+1] = r1[fi][fip];
	     fip = cimply[i+1];
	     n=n+1;
	    }
	  i=i+1;
	  }
      for(dev=1;dev<=so;++dev)
       {fprintf(sofp[dev],"\n%s%d%s%d%s\n%s\n", "Form ",
	      row," does not imply form ",
	      col," because of the following,",
	      "all of which are referenced in RFB1:");
	count = 0;
	for(i=0;i<k;++i)
	 {fprintf(sofp[dev],"%s%d%s", "form ", implyr[i], " is implied by ");
	  count = count+1;
	  if(count==3)
	   {fprintf(sofp[dev],"\n");
	    count = 0;
	   }
	 }
       if(k != 0)
	 fprintf(sofp[dev],"%s%d\n%s\n","form ",implyr[k],"and");
       count=0;
       for(i=0;i<n;++i)
	 {fprintf(sofp[dev],"%s%d%s", "form ", cimply[i], " implies ");
	  count = count + 1;
	  if(count==4)
	    {fprintf(sofp[dev],"\n");
	     count = 0;
	    }
	  }
       if(n!=0)
	 fprintf(sofp[dev],"%s%d\n%s\n","form ",cimply[n], "and");
       fprintf(sofp[dev],"%s%d%s%d\n","form ",
		   implyr[k]," does not imply form ",cimply[n]);
       }
      }
   if(im[row][col]=='2')
      {cimply[0]=row;
       cimply[1]=col;
       i=0;
       n=1;
       while(i<n)
	 {fi = cimply[i];
	  fip = cimply[i+1];
	  while(im[fi][fip] != '1')
	    {for(j=n; j>= i+1; --j)
	      cimply[j+1] = cimply[j];    /* for cimply */
	     cimply[i+1] = r1[fi][fip];
	     fip = cimply[i+1];
	     n=n+1;
	    }
	  i=i+1;
	  }
      for(dev=1;dev<=so;++dev)
       {fprintf(sofp[dev],"%s%d%s%d\n%s\n%s\n", "Form ", row,
	      " implies form ",col,
	      "because of the following implications",
	      "all of which are referenced in RFB1");
       count=0;
       for(i=0;i<n;++i)
	 {fprintf(sofp[dev],"%s%d%s", "form ", cimply[i], " implies ");
	  count = count + 1;
	  if(count==4)
	    {fprintf(sofp[dev],"\n");
	     count = 0;
	    }
	 }
      fprintf(sofp[dev],"%s%d\n","form ",col);
      }
     }
   if(im[row][col]=='1')
    for(dev=1;dev<=so;++dev)
      fprintf(sofp[dev],"\n%s%d%s%d\n%s\n", "Form ", row,
	     " implies form ",col,
	     "There is a reference in RFB1.");
   if(im[row][col]=='3' || im[row][col]== '5')
    for(dev=1;dev<=so;++dev)
      fprintf(sofp[dev],"\n%s%d%s%d\n%s\n", "Form ", row,
	     " does not imply form ",col,
	     "There is a reference in RFB1.");
   if(im[row][col]=='0' ||im[row][col]=='7')
    for(dev=1;dev<=so;++dev)
      {fprintf(sofp[dev],"\n%s\n%s%d%s%d\n", "It is unknown whether or not",
	      "form ", row, "implies form ",col);
       if(im[row][col]=='7')
	  fprintf(sofp[dev],"%s\n","There is a reference in RFB1.");
      }
  for(dev=1;dev<=so;++dev)
   fprintf(sofp[dev],"\n%s%d,%d%s%c\n","The entry at position ", row,
	  col," is  ",im[row][col]);
/*     }*/
LX:   printf("%s%s\n",
	     "Return to main menu ---- type 1  <enter>",
	     "     Exit program ---- type 2  <enter>");
      scanf("%d",&response);
       if(response != 1 && response !=2)
	 {printf("\n%d%s\n",response," is not a valid response");
	  goto LX;
	 }
       if(response ==1) goto L3;
       if(response==2) exit(1);
      }

     /* OPTION 7 */

    else if(response==7)
     {rd_mod();      /* function */
      goto L3;
     }

     /* OPTION 8 */

    else if(response==8)
      goto L5;
    goto L3;
L5: return;
}

     /* THE FUNCTIONS */

void rd_mod()
{  /* Local Variables */

    /* end local variables */

    if((ifp = fopen("models.tex","r"))==NULL)
      {if((ifp = fopen("models.dat","r")) == NULL)
	  {printf("\n%s\n","Neither models.tex nor models.dat is present.");
	   printf("%s\n","Menu item 7 requires one of these files");
	   goto B5;
	  }
      }

B: printf("\n%s\n%s\n%s\n",
	   "Enter the numbers of the forms that are to be TRUE.",
	   "Separate form numbers by one or more spaces.",
	   "Terminate your list of forms with -1.  Ten forms maximum");
    scanf("%d",&tempform);
    tr = 0;
    while(tempform >= 0)
     {tfrms[tr] = tempform;
      ++tr;
      scanf("%d",&tempform);
     }
   --tr;
    printf("\n%s\n%s\n%s\n",
	   "Enter the numbers of the forms that are to be FALSE.",
	   "Separate form numbers by one or more spaces.",
	   "Terminate your list of forms with -1.  Ten forms maximum");
    scanf("%d",&tempform);
    fr = 0;
    while(tempform >= 0)
     {ffrms[fr] = tempform;
      ++fr;
      scanf("%d",&tempform);
     }
   --fr;
    for(i=1;i<=so;++i)  /* so is 1 if no file, 2 if there is a file */
     { fprintf(sofp[i],"\n%s","Form");
       if(tr>0) fprintf(sofp[i],"%s","s");
       fprintf(sofp[i],"%s"," ");
       for(j=0;j <= tr;++j)
	 fprintf(sofp[i],"%d%s",tfrms[j],", ");
       if(tr>0) fprintf(sofp[i],"%s","are true");
       if(tr <= 0) fprintf(sofp[i],"%s","is true");
       fprintf(sofp[i],"\n%s","and form");
       if(fr>0) fprintf(sofp[i],"%s","s");
       fprintf(sofp[i],"%s"," ");
       for(j=0;j <= fr;++j)
	 fprintf(sofp[i],"%d%s",ffrms[j],", ");
       if(fr>0)
	 fprintf(sofp[i],"%s\n%s\n","are false","in the following models");
       if(fr<=0)
	 fprintf(sofp[i],"%s\n%s\n","is false","in the following models");
      }
   while(!feof(ifp))
     {
 /* Read a line of text from models.tex and check to see if it begins
 with either \bigskip\noindent or \smallskip\noindent */
      fgets(textline,100,ifp);
      i=0;
      while(textline[i] != ' '&& textline[i] != '\n' && i < 24)
	{word[i] = textline[i];
	 ++i;
	}
      word[i] = '\0';
      if(strcmp(word,"\\bigskip\\noindent") !=0 &&
		   strcmp(word,"\\smallskip\\noindent") != 0)
	goto L10;
      while(strcmp(word,"$\\Cal") != 0)
	{fgets(textline,100,ifp);  /* get the next line */
	      /* We're looking for $\Cal preceeding a model name */
	 i=0;
	 while(textline[i] == ' ')
	   ++i;
	 for(j=0;j<=4;++j)
	   {word[j] = textline[i];
	    ++i;
	   }
	 word[5] = '\0';
	}
	    /*Now read the model name into modname*/
      namel = 0;
      while(textline[i] != '$')
	{modname[namel] = textline[i];
	 ++namel;
	 ++i;
	}
      modname[namel] = '\0';

	   /* Now we look for the list of true and false forms */
	   /* Read a line of text from models.tex.  Skip
	      if first character is not $ or if the first two
	      characters are not "In".  */

L11:  fgets(textline,100,ifp);
      if((textline[0] !='$')&&(textline[0]!='I' || textline[1] != 'n') )
	 goto L11;
	       /* If the first character is '$',
	       check to see if the line starts with
	       "$\Cal ...\models"   */
      if(textline[0]=='$')
       {for(k=0;k<=4;++k)             /* read first five chars of */
	  {if(textline[k] =='\n')     /* textline into test12 plus */
	     goto L11;                 /* then skip up to the next */
	   test12[k] = textline[k];   /* $ character */
	  }
	k=5;
	while(textline[k] != '$')
	  {if(textline[k] =='\n')
	     goto L11;
	   k = k+1;
	  }
	k = k-1;
	while(textline[k] != '\\')      /* now back up to the first */
	  {if(textline[k] == '$')       /* \ character but skip the */
	     goto L11;                  /* line if you hit $ first   */
	   k=k-1;
	  }
	for(i=5;i <= 11;++i)           /* add 6 letter Tex control */
	  {if(textline[k] == '\n')
	     goto L11;
	   test12[i] = textline[k];    /* word to test12 (we're  */
	   k = k + 1;                  /* looking for $\Cal\models */
	  }
	test12[12] = '\0';
	if(strcmp(test12,"$\\Cal\\models") != 0)  /* if this isn't the */
	   goto L11;                  /* line with the models */
	tnm = -1;    /* initialize form counters */
	fnm = -1;
	word[0] = '\0';  /* initialize word */
	   while(textline[k] == ' ' || textline[k] == ','
		      || textline[k] == '(')
	     k = k+1;                            /* read past spaces & ,s */
	   if(textline[k]=='\n')
						 /* if at end of line, get */
	     {fgets(textline,100,ifp);           /* a new line and reset */
	      k=0;                               /* line pointer  */
	     }
	   ind = 0;                              /* index for array 'word' */
	   while((textline[k] != ' '&& textline[k] != ',')&& (textline[k]
		  != '\n' && textline[k] != '('))
	     {word[ind] = textline[k];           /* read the next word */
	      k = k+1;                           /* into 'word'  */
	      ind = ind + 1;
	     }
	   word[ind] = '\0';           /*make 'word' into a string */

   /* now put the numbers of forms that are true in the model
      into the array trueinM */

	   while(strcmp(word,"but") != 0)
	     {for(i=0;i<= ind-1;++i)               /* check to see if word */
	       if(!isdigit(word[i]))              /* is a number  */
		 goto LAB1;
	      tnm = tnm + 1;                       /* if it is, add to the */
	      trueinM[tnm] = atoi(word);            /* array trueinM  */
LAB1:         ind = 0;
	      while(textline[k] == ' ' || textline[k] == ','||
		       textline[k] == '(')
		k = k+1;
	      if(textline[k]=='\n')
						    /* if at end of line, get */
		{fgets(textline,100,ifp);           /* a new line and reset */
		 k=0;                               /* line pointer  */
		}
	      while((textline[k] != ' '&& textline[k] != ',')&& (textline[k]
		  != '\n' && textline[k] != '('))
	       {word[ind] = textline[k];           /* read the next word */
		k = k+1;                           /* into 'word'  */
		ind = ind + 1;
	       }
	      word[ind]='\0';
	     }
    /* get numbers of forms that are false in the model */

	   while(strcmp(word,"false.") != 0 )
	     {for(i=0;i<=ind-1;++i)
	       if(!isdigit(word[i]))
		 goto LAB2;
	     fnm = fnm + 1;
	     falseinM[fnm] = atoi(word);
LAB2:        ind = 0;
	     while(textline[k]==' ' || textline[k] == ',' ||
		      textline[k] == '(')
	       k = k + 1;
	     if(textline[k]=='\n')
						    /* if at end of line, get */
		{fgets(textline,100,ifp);           /* a new line and reset */
		 k=0;                               /* line pointer  */
		}

	     while((textline[k] != ' '&& textline[k] != ',')&& (textline[k]
		  != '\n' && textline[k] != '('))
	       {word[ind] = textline[k];           /* read the next word */
		k = k+1;                           /* into 'word'  */
		ind = ind + 1;
	       }
	      word[ind] = '\0';
	     }
	    }
   /* If the first two characters of the line are "In" check to see if the
   line begins with "In $\Cal ...$, form..."   */
	    if((textline[0]=='I') && (textline[1]=='n'))
	    {k = 3;
	     for(i=0;i<=4;++i)
	       {word[i] = textline[k];
		k=k+1;
	       }
	     word[5] = '\0';
	     if(strcmp(word,"$\\Cal") != 0)   /* checking for $\Cal */
		goto L11;
	     while(textline[k] != '$')      /* read past next $ */
	       k=k+1;
	     k=k+1;
	     for(i=0;i<=5;++i)
	       {word[i] = textline[k];
		k=k+1;
	       }
	     ind = 6;
	     word[6]='\0';
	     if(strcmp(word,", form") != 0)
		goto L11;
	     fnm = -1;
	     tnm = -1;

/* Put numbers of false forms into the array falseinM */

	   while(strcmp(word,"false.") != 0 )
	     {for(i=0;i<=ind-1;++i)
	       if(!isdigit(word[i]))
		 goto LAB3;
	     fnm = fnm + 1;
	     falseinM[fnm] = atoi(word);
LAB3:        ind = 0;
	     while(textline[k]==' ' || textline[k] == ',' ||
			textline[k] == '(')
	       k = k + 1;
	     if(textline[k]=='\n')
						    /* if at end of line, get */
		{fgets(textline,100,ifp);           /* a new line and reset */
		 k=0;                               /* line pointer  */
		}

	     while((textline[k] != ' '&& textline[k] != ',')&& (textline[k]
		  != '\n' && textline[k] != '('))
	       {word[ind] = textline[k];           /* read the next word */
		k = k+1;                           /* into 'word'  */
		ind = ind + 1;
	       }
	      word[ind] = '\0';
	     }

	   }

     /* Replace form numbers that are not needed in the arrays
	trueinM and falseinM -1     */

	   for(i=0;i<= tnm;++i)
	     for(j=0;j <= tnm; ++j)
	       if(j != i && trueinM[i] >= 0 && trueinM[j] >= 0)
		 if(im[trueinM[i]][trueinM[j]] == '1' ||
			    im[trueinM[i]][trueinM[j]] == '2')
		   trueinM[j] = -1;

	   for(i=0;i<= fnm;++i)
	     for(j=0;j<= fnm;++j)
	       if(j != i && falseinM[i] >= 0 && falseinM[j] >= 0)
		 if(im[falseinM[j]][falseinM[i]] == '1' ||
		      im[falseinM[j]][falseinM[i]] == '2')
		   falseinM[j] = -1;

		/* Determine whether or not the model satifies the
		   desired properites */
	flag = 1;   /* 1 means "the model satisfies all properties
		       checked so far */
	for(j=0;j<= tr;++j)
	  {flag1 = 0;
	   for(i=0;i<=tnm;++i)
	   if(trueinM[i] >= 0)
	     if(im[trueinM[i]][tfrms[j]] == '1' ||
		im[trueinM[i]][tfrms[j]] == '2')
	       flag1 = 1;
	   if(tfrms[j]==0) flag1 = 1;
	   flag = flag*flag1;
	  }
	for(j=0;j<=fr;++j)
	  {flag1 = 0;
	   for(i=0;i<=fnm;++i)
	   if(falseinM[i] >= 0)
	     if(im[ffrms[j]][falseinM[i]] == '1' ||
		im[ffrms[j]][falseinM[i]] == '2')
	       flag1 = 1;
	   if(ffrms[j]==1) flag1 = 1;
	   flag = flag*flag1;
	  }

	      /* Write the name of the model if it works */

	if(flag ==1)
	  for(i=1;i<= so;++i)
	   fprintf(sofp[i],"%s\n",modname);
L10:  ind = 0;
     }    /* end of while(nfeof,ifp) loop */
     printf("\n\n%s%s\n%s","Repeat Program with a new list of forms? ---",
     " r <enter>", "Return to main menu --- m <enter>");
B2:  gets(yes);
 /*    if(strcmp(yes,"y") == 0 || strcmp(yes,"Y") == 0) */
    if(strcmp(yes,"")==0) goto B2;
    if(*yes == 'r' || *yes =='R')
      {rewind(ifp);
       goto B;
      }
    fclose(ifp);
B5: return;
}